<template>
  <div>
    <el-card class="el-card">
      <el-form :model="filterQuery" class="query-form" size="mini" :inline="true">
        <el-form-item class="query-form-item" label="领用记录号:">
          <el-input v-model="filterQuery.orderId" placeholder="请输入领用记录号"
                    clearable="true"></el-input>
        </el-form-item>
        <el-form-item class="query-form-item" label="领用部门:">
          <el-select v-model="filterQuery.fromDeptCode" placeholder="请选择部门" clearable="true"
                     @change="deptChange"
          >
            <el-option
              v-for="item in deptList"
              :key="item.name"
              :label="item.name"
              :value="item.code">
              <span style="float: left">{{ item.name }}</span>
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item class="query-form-item" label="领用仓库:">
          <el-select v-model="filterQuery.fromInvCode" placeholder="请选择仓库" clearable="true"
                     @change="invChange"
          >
            <el-option
              v-for="item in invList"
              :key="item.name"
              :label="item.name"
              :value="item.code">
              <span style="float: left">{{ item.name }}</span>
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item class="query-form-item" label="领用货位:">
          <el-select v-model="filterQuery.fromInvSpaceCode" placeholder="请选择货位" clearable="true"
          >
            <el-option
              v-for="item in spaceList"
              :key="item.name"
              :label="item.name"
              :value="item.code">
              <span style="float: left">{{ item.name }}</span>
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item>
          <el-button-group style="margin-left: 10px;display:flex;">
            <el-button type="primary" icon="el-icon-refresh" @click="onReset">重置</el-button>
            <el-button type="primary" icon="el-icon-search" @click="onSubmit">查询</el-button>
          </el-button-group>
        </el-form-item>
      </el-form>

      <el-table v-loading="loading" :data="list" style="width: 100%" highlight-current-row
                @current-change="handleChange"
                border>
        <el-table-column label="序号" type="index"></el-table-column>
        <el-table-column label="设备领用记录号" prop="orderId"></el-table-column>
        <el-table-column label="领用部门" prop="fromDeptName"></el-table-column>
        <el-table-column label="领用仓库" prop="fromInvName"></el-table-column>
        <el-table-column label="领用货位" prop="fromInvSpaceName"></el-table-column>
        <el-table-column label="领用日期" prop="createTime"></el-table-column>
        <el-table-column label="领用人" prop="receiveUserName"></el-table-column>
        <el-table-column label="创建人" prop="createUser"></el-table-column>
        <el-table-column label="状态" prop="status" show-overflow-tooltip width="120">
          <template slot-scope="scope">
            <el-tag>{{ statusMap[scope.row.status] }}</el-tag>
          </template>
        </el-table-column>
        <el-table-column label="操作">
          <template slot-scope="scope">
            <el-button
              type="text"
              size="small"
              @click.native.stop="auditOrder(scope.row)"
            >审核
            </el-button
            >
            <el-button
              type="text"
              size="small"
              @click.native.stop="deleteDialog(scope.row.id)"
            >删除
            </el-button
            >
          </template>
        </el-table-column>
      </el-table>
      <pagination
        v-show="total>0"
        :total="total"
        :limit.sync="filterQuery.limit"
        :page.sync="filterQuery.page"
        @pagination="getList"
      ></pagination>
    </el-card>

    <el-card>
      <el-table v-loading="detailLoading" :data="detailList" style="width: 100%; margin-top: 10px;">
        <el-table-column label="序号" type="index" width="50"></el-table-column>
        <el-table-column label="条码" width="200" prop="code" show-overflow-tooltip></el-table-column>
        <el-table-column label="产品通用名" prop="productName" width="200"></el-table-column>
        <el-table-column label="规格型号" prop="ggxh" width="180" show-overflow-tooltip></el-table-column>
        <el-table-column label="批次号" prop="batchNo" width="150"></el-table-column>
        <el-table-column label="序列号" prop="serialNo" width="150"></el-table-column>
        <el-table-column label="领用日期" prop="createTime" width="150"></el-table-column>
        <el-table-column label="生产日期" prop="productionDate" width="150"></el-table-column>
        <el-table-column label="失效日期" prop="expireDate" width="150"></el-table-column>
        <el-table-column label="注册/备案凭证号" prop="zczbhhzbapzbh"
                         show-overflow-tooltip></el-table-column>
        <el-table-column  label="生产厂家" prop="ylqxzcrbarmc"
                         show-overflow-tooltip></el-table-column>
      </el-table>

      <pagination
        v-show="detailTotal>0"
        :total="detailTotal"
        :limit.sync="detailQuery.limit"
        :page.sync="detailQuery.page"
        @pagination="getDetailList"
      ></pagination>
    </el-card>

  </div>
</template>

<script>
import {getDeptListByUser} from "@/api/auth/authDept";
import {findInvByUser} from "@/api/system/invSubWarehouse";
import {getInvSpaceList} from "@/api/inventory/invSpace";
import {
  getDeviceReceiveOrderDetailList,
  updateDeviceReceiveOrderStatus,
  deleteDeviceReceiveOrder,
  getDeviceReceiveOrderList
} from "@/api/inventory/deviceReceiveOrder";

export default {
  name: "DeviceReceiveOrderAudit",
  data() {
    return {
      filterQuery: {
        orderId: null,
        fromDeptCode: this.$store.getters.locDeptCode,
        fromInvCode: null,
        fromInvSpaceCode: null,
        status: 1,
        page: 1,
        limit: 20,
      },
      list: [],
      total: 0,
      deptList: [],
      invList: [],
      spaceList: [],
      loading: false,
      statusMap: {
        0: "草稿",
        1: "未审核",
        2: "已审核"
      },
      detailQuery: {
        orderIdFk: null,
        page: 1,
        limit: 20,
      },
      detailList: [],
      detailLoading: false,
      detailTotal: 0
    };
  },
  methods: {
    onReset() {
      this.$router.push({
        path: "",
      });
      this.filterQuery = {
        orderId: null,
        fromDeptCode: this.$store.getters.locDeptCode,
        fromInvCode: null,
        fromInvSpaceCode: null,
        status: 1,
        page: 1,
        limit: 20,
      };
      this.spaceList = [];
      this.getList();
    },
    onSubmit() {
      this.filterQuery.page = 1;
      this.getList();
    },
    getList() {
      this.loading = true;
      getDeviceReceiveOrderList(this.filterQuery).then((res) => {
        this.loading = false;
        if (res.code === 20000) {
          this.list = res.data.list || [];
          this.total = res.data.total || 0;
        } else {
          this.$message.error(res.message);
          this.list = [];
          this.total = 0;
        }
      }).catch((error) => {
        this.loading = false;
        this.$message.error(error.message);
        this.list = [];
        this.total = 0;
      })
    },
    deptChange() {
      this.invList = [];
      this.spaceList = [];
      this.filterQuery.fromInvCode = null;
      this.filterQuery.fromInvSpaceCode = null;
      this.getInvList();
    },
    getDeptList() {
      getDeptListByUser().then((res) => {
        this.deptList = res.data || [];
        this.getInvList();
        this.getList();
      });
    },
    invChange() {
      this.spaceList = [];
      this.filterQuery.fromInvSpaceCode = null;
      this.getSpaceList();
    },
    getInvList() {
      let params = {deptCode: this.filterQuery.fromDeptCode};
      findInvByUser(params)
        .then((response) => {
          this.invList = response.data || [];
          this.getList();
        })
        .catch(() => {
        });
    },
    getSpaceList() {
      let params = {invWarehouseCode: this.filterQuery.fromInvCode,invStorageCode:this.filterQuery.fromInvCode.fromDeptCode, status: 1};
      getInvSpaceList(params).then((res) => {
        this.spaceList = res.data.list || [];
        this.getList();
      })
    },
    auditOrder(row) {
      this.$confirm('请选择审核意见', '提示', {
        confirmButtonText: '通过',
        cancelButtonText: '驳回',
        type: 'warning',
        center: true,
        closeOnPressEscape: false,//按下 ESC 键关闭弹窗
        closeOnClickModal: false,//点击遮罩关闭弹窗
        distinguishCancelAndClose: true,//区分取消与关闭
      }).then(() => {
        let params = {
          id: row.id,
          status: 2
        };
        updateDeviceReceiveOrderStatus(params).then((res) => {
          if (res.code === 20000) {
            this.$message.success("审核通过！");
            this.getList();
          } else {
            this.$message.error(res.message);
          }
        }).catch((error) => {
          this.$message.error(error.message);
        })
      }).catch((action) => {
        if (action === "cancel") {
          let params = {
            id: row.id,
            status: 0
          };
          updateDeviceReceiveOrderStatus(params).then((res) => {
            if (res.code === 20000) {
              this.$message.success("已驳回！")
              this.getList();
            } else {
              this.$message.error(res.message);
            }
          }).catch((error) => {
            this.$message.error(error.message);
          });
        } else {
          return;
        }
      });
    },
    handleChange(row) {
      this.detailQuery.orderIdFk = row.orderId;
      this.detailQuery.page = 1;
      this.getDetailList();
    },
    getDetailList() {
      getDeviceReceiveOrderDetailList(this.detailQuery).then((res) => {
        if (res.code === 20000) {
          this.detailList = res.data.list || [];
          this.detailTotal = res.data.total || 0;
        } else {
          this.detailList = [];
          this.detailTotal = 0;
        }
      }).catch(() => {
        this.detailList = [];
        this.detailTotal = 0;
      });
    },
    deleteDialog(rowId) {
      this.$confirm('此操作将永久删除该领用记录, 是否继续?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        let params = {id: rowId};
        this.loading = true;
        deleteDeviceReceiveOrder(params).then((res) => {
          this.loading = false;
          if (res.code === 20000) {
            this.$message.success("删除成功！");
            this.getList();
          } else {
            this.$message.error(res.message);
          }
        }).catch(() => {
          this.loading = false;
        });
      });
    },
    closeDialog() {
      this.formVisible = false;
      this.getList();
    },
  },
  mounted() {
    document.body.ondrop = function (event) {
      event.preventDefault();
      event.stopPropagation();
    };
  },
  created() {
    this.getDeptList();
  },
};
</script>

<style type="text/scss" lang="scss">
</style>

